HDU 3661 Assignments

题目链接:

http://acm.split.hdu.edu.cn/showproblem.php?pid=3661

Problem Description

In a factory, there are N workers to finish two types
of tasks (A and B). Each type has N tasks. Each task of type A needs xi time to
finish, and each task of type B needs yj time to finish, now, you, as the boss
of the factory, need to make an assignment, which makes sure that every worker
could get two tasks, one in type A and one in type B, and, what‘s more, every
worker should have task to work with and every task has to be assigned. However,
you need to pay extra money to workers who work over the standard working hours,
according to the company‘s rule. The calculation method is described as follow:
if someone’ working hour t is more than the standard working hour T, you should
pay t-T to him. As a thrifty boss, you want know the minimum total of overtime
pay.

Input

There are multiple test cases, in each test case there
are 3 lines. First line there are two positive Integers, N (N<=1000) and T
(T<=1000), indicating N workers, N task-A and N task-B, standard working hour
T. Each of the next two lines has N positive Integers; the first line indicates
the needed time for task A1, A2…An (Ai<=1000), and the second line is for B1,
B2…Bn (Bi<=1000).

Output

For each test case output the minimum Overtime wages by
an integer in one line.

Sample Input

2 5

4 2

3 5

Sample Output

4

Hint:

题意:

有两个长度为N(N<=1000)的序列A和B,把两个序列中的共2N个数分为N组,使得每组中的两个数分别来自A和B,每组的分数等于max(0,组内两数之和-t),问所有组的分数之和的最小值

题解:

贪心。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn = 1000+10;
int a[maxn],b[maxn];
int main()
{
    int n,t;
    while(scanf("%d%d", &n,&t)!=EOF)
    {
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        for(int i=0;i<n;i++)
            scanf("%d",&b[i]);
        sort(a,a+n);
        sort(b,b+n);
        int sum=0;
        for(int i=0,j=n-1;i<n;i++,j--)
        {
            if(a[i]+b[j]>t)
                sum+=(a[i]+b[j]-t);
            else
                sum+=0;
        }
        printf("%d\n",sum);
    }
}

  

时间: 2024-08-28 01:14:46

HDU 3661 Assignments的相关文章

hdu 3661 Assignments 贪心

Assignments Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1637    Accepted Submission(s): 759 Problem Description In a factory, there are N workers to finish two types of tasks (A and B). Eac

HDU 3661 Assignments (水题,贪心)

题意:n个工人,有n件工作a,n件工作b,每个工人干一件a和一件b,a[i] ,b[i]代表工作时间,如果a[i]+b[j]>t,则老板要额外付钱a[i]+b[j]-t;现在要求老板付钱最少: 析:贪心策略,让大的和小的搭配,小的和大的搭配,是最优的. 代码如下: #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include <string> #incl

POJ 1274 The Perfect Stall、HDU 2063 过山车(最大流做二分匹配)

The Perfect Stall Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 24081   Accepted: 10695 Description Farmer John completed his new barn just last week, complete with all the latest milking technology. Unfortunately, due to engineering p

hdu 1227(经典dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1227 Fast Food Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 2165    Accepted Submission(s): 926 Problem Description The fastfood chain McBurger

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是